unit Tree;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, DBTables, Outline,
  StdCtrls;

type
  PParent=^Integer;
  TForm1 = class(TForm)
    ParentTable: TTable;
    DataSource1: TDataSource;
    ChildTable: TTable;
    DataSource2: TDataSource;
    Button2: TButton;
    Add_child: TStoredProc;
    Database1: TDatabase;
    PathEdit: TEdit;
    Header1: THeader;
    Outline1: TOutline;
    Get_path: TStoredProc;
    ParentTablePARENT_ID: TSmallintField;
    ParentTableCHILD_ID: TSmallintField;
    ParentTablePATHSTRING: TStringField;
    ChildTableCHILD_ID: TSmallintField;
    ChildTablePARENT_ID: TSmallintField;
    ChildTablePATHSTRING: TStringField;
    Button1: TButton;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Outline1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
 procedure  TreeStep(parentID,Ind:Longint);
var
  Form1: TForm1;
  PParentID:Pparent;
implementation

{$R *.DFM}
function TrimSpaces(S : string) : string;
   {-Return a string with leading and trailing blanks removed}
  begin
   while (Length(S) > 0) and (S[1] = ' ') do
    Delete(S, 1, 1);
   while (Length(S) > 0) and (S[Length(S)] = ' ') do
    Dec(S[0]);
   TrimSpaces := S;
  end;
procedure TForm1.Button2Click(Sender: TObject);
begin
Database1.StartTransaction;
try
  Add_child.ParamByName('P_ID').AsInteger := PParent(Outline1.Items[Outline1.SelectedItem].Data)^;
  Add_child.ParamByName('PATHS').AsString := TrimSpaces(PathEdit.Text);
  Add_child.ExecProc;
  PParentID:=New(Pparent);
  PParentID^:= Add_child.ParamByName('PARENTID').AsInteger ;
  OutLine1.AddChildObject(OutLine1.SelectedItem,PathEdit.Text,PParentID)
finally
begin
  Database1.Commit;
  ParentTable.Refresh;
  ChildTable.Refresh;
end;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
Ind:LongInt;
begin
   Database1.Connected:=True;
   ParentTable.First;
   PParentID:=New(Pparent);
   PParentID^:=ParentTablePARENT_ID.AsInteger;
   Ind:=OutLine1.AddObject(0,ParentTablePATHSTRING.AsSTring,PParentID);
   TreeStep(ParentTablePARENT_ID.AsInteger,Ind);
   Header1.Sections.Add('');
   OutLine1Click(Sender);
end;
{Fill  OutLine1 up}
 procedure TreeStep(parentID,Ind:LongInt);
 var Bm:TBookMark;
     Bmp:TBookMark;
     PID,CID:Integer;

     I:LongInt;
 begin
  with Form1 do
  begin
    begin
    while not ChildTable.EOF  do
    begin
      PID:=ParentTablePARENT_ID.AsInteger;
      CID:=ChildTableCHILD_ID.AsInteger;
      if ParentTable.FindKey([CID]) then
      begin
        PParentID:=New(Pparent);
        PParentID^:=ParentTablePARENT_ID.AsInteger;
        I:=OutLine1.AddChildObject(Ind,ParentTablePATHSTRING.AsString,PParentID);
        TreeStep(ParentTablePARENT_ID.AsInteger,I);
      end;
      ParentTable.FindKey([PID]);
      ChildTable.Findkey([PID,CID]);
      ChildTable.Next;
    end;
   end;
  end;
 end;
{Getting the node's path from Interbase with via a stored proc.}
procedure TForm1.Outline1Click(Sender: TObject);
begin
   Database1.StartTransaction;
   Get_path.ParamByName('P_ID').AsInteger :=PParent(Outline1.Items[Outline1.SelectedItem].Data)^;
   Get_path.ExecProc;
   Header1.Sections.Strings[0]:=Get_path.ParamByName('PATHS').AsString ;
   Database1.Commit;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Database1.Connected:=False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Form1.Close;
end;

end.
