
CONNECT "c:\DELPHI\TREE\tree.gdb"
USER "MYNAME" PASSWORD "mypassword";

CREATE TABLE parent
  (
      parent_id SMALLINT NOT NULL,
      child_id  SMALLINT NOT NULL ,
      pathstring VARCHAR(30),
      PRIMARY KEY (parent_id)
  );
CREATE TABLE child
  (
      child_id  SMALLINT   NOT NULL ,
      parent_id SMALLINT   NOT NULL ,
      pathstring VARCHAR(30),
      PRIMARY KEY (child_id)
  );

CREATE GENERATOR f_id_gen;
CREATE GENERATOR c_id_gen;
SET GENERATOR c_id_gen TO 1;

SET TERM  ^ ;
CREATE TRIGGER ADD_PARENT FOR CHILD
AFTER INSERT AS
BEGIN
   INSERT INTO parent(PARENT_ID,CHILD_ID,PATHSTRING)
     VALUES(GEN_ID(f_id_gen,1),new.child_id,new.pathstring);
END ^

CREATE PROCEDURE ADD_CHILD (P_ID SMALLINT,PATHS VARCHAR(30))
	  RETURNS (parentid SMALLINT)
AS
DECLARE VARIABLE cid SMALLINT;
BEGIN
   cid=GEN_ID(c_id_gen,1);
   INSERT INTO child (CHILD_ID,PARENT_ID,PATHSTRING)
   VALUES(:cid,:P_ID,:PATHS);
   SELECT parent.parent_id FROM parent 
          WHERE parent.child_id=:cid INTO :parentid;
   SUSPEND;
END ^

/* Ez adja vissza egy csompont elrsi tvonalt*/
CREATE PROCEDURE GET_PATH (p_id SMALLINT)
   RETURNS(paths VARCHAR(100))
AS
DECLARE VARIABLE pid SMALLINT;
DECLARE VARIABLE path VARCHAR(30);
BEGIN
   paths='';
 BEGIN
   SELECT PATHSTRING
           FROM PARENT
           WHERE PARENT.PARENT_ID=:p_id
           INTO :path;
   SELECT CHILD.PARENT_ID
           FROM PARENT,CHILD
           WHERE PARENT.PARENT_ID=:p_id AND PARENT.CHILD_ID=CHILD.CHILD_ID
           INTO :pid;
   IF  (:pid IS NULL) THEN
   BEGIN
          paths=:path ;
          EXIT;
   END
   ELSE
      EXECUTE PROCEDURE GET_PATH :pid
             RETURNING_VALUES :paths;
  END
   paths=:paths||'/'||:path ;
END ^
SET TERM ;^
COMMIT WORK ;

INSERT INTO parent (parent_id,child_id,pathstring )
       VALUES (GEN_ID(f_id_gen,1),0,'c:');

CREATE INDEX cparent ON child (parent_id,child_id);
COMMIT;
SET TERM ^ ;
